package no.twofingers.iControl;

import sun.tools.javap.JavaP;
import java.io.*;
import java.util.StringTokenizer;
import java.util.List;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.Stack;

/**
 * This interface represents a Java Class that can have DBC assertions turned on or off
 * TODO: Add method visibility invariant
 *
 * @author  <a href="mailto:aslak.hellesoy@bekk.no">Aslak Hellesy</a>
 */
public class DBCPackage extends Setting {

	public static final String DEFAULT_PACKAGE = "[Default Package]";

	private final String packageName;

	/**
	 * Creates a new DBCPackage
	 *
	 */
	public DBCPackage( DBCProject parent, File rootDir, File packageDir ) {
		super( parent );
		File dir = packageDir;
		Stack dirs = new Stack();
		while( !rootDir.equals( dir ) ) {
			dirs.push( dir );
			dir = dir.getParentFile();
		}
		StringBuffer sb = new StringBuffer();
		while( !dirs.empty() ) {
			sb.append( ((File) dirs.pop()).getName() );
			if( !dirs.isEmpty() ) {
				sb.append( "." );
			}
		}
		String candidate = sb.toString();

		if( candidate.equals( "" ) ) {
			this.packageName = DEFAULT_PACKAGE;
		} else {
			this.packageName = candidate;
		}

		fireAnalyzingSetting( this );

		//Logger.get().info( "  " + packageName );

		File[] classFiles = packageDir.listFiles( classFilter );
		for( int i = 0; i < classFiles.length; i++ ) {
			String classFileName = classFiles[ i ].getName();
			String className = classFileName.substring( 0, classFileName.length() - 6 );
			if( className.indexOf( '$' ) == -1 ) { // iContract doesn't support inner classes
				DBCClass dbcClass = new DBCClass( this, className );
				addChild( dbcClass );
			} else {
				// log that
			}
		}
	}

	public String getDisplayName() {
		return packageName;
	}

	public String getQualifiedName() {
		return packageName;
	}
}

