package no.twofingers.iControl;

import java.io.*;

/**
 * This interface represents a Java Class that can have DBC assertions turned on or off
 *
 * @author <a href="mailto:aslak.hellesoy@bekk.no">Aslak Hellesy</a>
 */
public class DBCProject extends Setting {

	/**
	 * Creates a new DBCPackage
	 *
	 */
	public DBCProject( File rootDir ) {
		super( null );
		resetErrors();
		scanPackages( rootDir, rootDir );
	}

	private void scanPackages( File root, File dir ) {
		File[] packageDirs = dir.listFiles( Setting.directoryFilter );
		if( packageDirs != null ) {
			for( int i = 0; i < packageDirs.length; i++ ) {
				DBCPackage dbcPackage = new DBCPackage( this, root, packageDirs[ i ] );
				// don't add empty packages
				if( dbcPackage.getChildren().size() > 0 ) {
					addChild( dbcPackage );
				} else {
					// Logger.get().info( "    (No classes in this package)" );
				}
				scanPackages( root, packageDirs[ i ] );
			}
		} else {
			// log4j
			System.out.println( "No packages under " + dir.getAbsolutePath() );
			// FIXME: accept default package too!!
			System.out.println( "You have to use a package." );
			System.exit( 1 );
		}
	}

	public String getDisplayName() {
		return "Project";
	}

	public String getQualifiedName() {
		return "Project";
	}
}

