/*
 * IControlPanel.java
 *
 * Created on 16. mars 2001, 00:54
 */

package no.twofingers.iControl.swing;

import java.awt.Color;
import java.awt.Dimension;
import javax.swing.*;
import javax.swing.tree.*;
import com.sun.swing.treetable.*;
import no.twofingers.iControl.*;

/**
 *
 * @author  Aslak Hellesy
 * @version
 */
public class AssertionPanel extends javax.swing.JPanel {

	private IControl _iControl;
	private JScrollPane scrollPane;
	private JTreeTable treeTable;
	private IControlTreeTableModel _iControlTreeTableModel;
//	private final SettingCellEditorRenderer _settingCellRenderer = new SettingCellEditorRenderer();
//	private final SettingCellEditorRenderer _settingCellEditor = new SettingCellEditorRenderer();

	/** Creates new form IControlPanel */
	public AssertionPanel() {
	}
	
	public void setIControl( IControl iControl ) {
		_iControl = iControl;
		_iControlTreeTableModel = new IControlTreeTableModel( iControl );
		initComponents ();
	}
	
	public Dimension getPreferredSize() {
		return new Dimension( 600, 300 );
	}
	
	private void initComponents() {
		scrollPane = new javax.swing.JScrollPane();
		treeTable = new JTreeTable( _iControlTreeTableModel );

		// set renderers for each of the setting columns
		SettingRenderer settingRenderer = new SettingRenderer();
		treeTable.getColumnModel().getColumn( 1 ).setCellRenderer( settingRenderer );
		treeTable.getColumnModel().getColumn( 2 ).setCellRenderer( settingRenderer );
		treeTable.getColumnModel().getColumn( 3 ).setCellRenderer( settingRenderer );

		SettingTreeCellRenderer stcr = new SettingTreeCellRenderer();
		stcr.setBackgroundSelectionColor( treeTable.getBackground() );
		treeTable.getTree().setCellRenderer( stcr );

		// set editors for each of the setting columns
		SettingEditor settingEditor = new SettingEditor();
		treeTable.getColumnModel().getColumn( 1 ).setCellEditor( settingEditor );
		treeTable.getColumnModel().getColumn( 2 ).setCellEditor( settingEditor );
		treeTable.getColumnModel().getColumn( 3 ).setCellEditor( settingEditor );

		// don't want selection color in tree
		treeTable.setSelectionBackground( treeTable.getBackground() );

		treeTable.sizeColumnsToFit( 0 );

		// don't allow the user to drag columns around
		treeTable.getTableHeader().setReorderingAllowed( false );

		scrollPane.setViewportView(treeTable);

		setLayout(new java.awt.BorderLayout());
		add(scrollPane, java.awt.BorderLayout.CENTER);

	}
}
