/*
 * ConfigPanel.java
 *
 * Created on 26. mars 2001, 22:27
 */

package no.twofingers.iControl.swing;

import java.io.File;

import java.util.ArrayList;
import java.util.StringTokenizer;
import java.util.Properties;

import javax.swing.DefaultListModel;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;

import javax.swing.filechooser.FileFilter;

import no.twofingers.iControl.IControl;

/**
 *
 * @author  Aslak Hellesy
 * @version
 */
public class ConfigPanel extends javax.swing.JPanel {
	
	private IControl _iControl;
	private DefaultListModel _model;
	private JFileChooser _chooser = new JFileChooser();
	
	private FileFilter _jarFilter = new FileFilter() {
		public boolean accept( File file ) {
			return file.getName().toLowerCase().endsWith( ".jar" ) || file.isDirectory();
		}
		
		public String getDescription() {
			return "Jar files";
		}
	};
	
	/** Creates new form ConfigPanel */
	public ConfigPanel() {
		initComponents ();
		
		_chooser.setSelectedFile( new File( System.getProperty( "user.dir" ) ) );
		_chooser.setFileFilter( _jarFilter );
		_model = new DefaultListModel();
		
		jList1.setModel( _model );
	}
	
	public void setIControl( IControl iControl ) {
		_iControl = iControl;
		setClasspath( iControl.getClasspath() );
	}
	
	private void setClasspath( String classpath ) {
		StringTokenizer st = new StringTokenizer( classpath, File.pathSeparator );
		ArrayList warnings = new ArrayList();
		while( st.hasMoreTokens() ) {
			File file = new File( st.nextToken() );
			if( !file.exists() ) {
				warnings.add( file );
			}
			_model.addElement( file.getAbsolutePath() );
		}
		if( warnings.size() != 0 ) {
			JOptionPane.showMessageDialog( this, warnings.toArray(), "The following path elements don't exist:", JOptionPane.WARNING_MESSAGE );
		}
	}
	
	public void storeClasspath() {
		Properties props = _iControl.getProperties();
	}
	
	private String getClasspath() {
		StringBuffer sb = new StringBuffer();
		for( int i = 0; i < _model.size() - 1; i++ ) {
			sb.append( _model.get( i ) ).append( File.separatorChar );
		}
		if( _model.size() > 0 ) {
			sb.append( _model.getElementAt( 0 ) );
		}
		return sb.toString();
	}
	
	 /** This method is called from within the constructor to
	  * initialize the form.
	  * WARNING: Do NOT modify this code. The content of this method is
	  * always regenerated by the FormEditor.
	  */
	private void initComponents() {//GEN-BEGIN:initComponents
		jScrollPane1 = new javax.swing.JScrollPane();
		jList1 = new javax.swing.JList();
		jPanel1 = new javax.swing.JPanel();
		jButton1 = new javax.swing.JButton();
		jButton2 = new javax.swing.JButton();
		jLabel1 = new javax.swing.JLabel();
		setLayout(new java.awt.BorderLayout());
		
		
		jScrollPane1.setViewportView(jList1);
  		
  		
		add(jScrollPane1, java.awt.BorderLayout.CENTER);
		
		
		
		jButton1.setText("Add");
  		jButton1.addActionListener(new java.awt.event.ActionListener() {
  			public void actionPerformed(java.awt.event.ActionEvent evt) {
  				jButton1ActionPerformed(evt);
  			}
  		}
  		);
  		jPanel1.add(jButton1);
  		
  		
		jButton2.setText("Remove");
  		jButton2.addActionListener(new java.awt.event.ActionListener() {
  			public void actionPerformed(java.awt.event.ActionEvent evt) {
  				jButton2ActionPerformed(evt);
  			}
  		}
  		);
  		jPanel1.add(jButton2);
  		
  		
		add(jPanel1, java.awt.BorderLayout.SOUTH);
		
		
		jLabel1.setText("classpath elements");
		
		add(jLabel1, java.awt.BorderLayout.NORTH);
		
	}//GEN-END:initComponents
	
  private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
	  // Add your handling code here:
	  Object[] selected = jList1.getSelectedValues();
	  if( selected != null ) {
		  for( int i = 0; i < selected.length; i++ ) {
			  _model.removeElement( selected[ i ] );
		  }
	  }
  }//GEN-LAST:event_jButton2ActionPerformed
  
  private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
	  // Add your handling code here:
	  File file = getFile();
	  if( file != null ) {
		  _model.addElement( file.getAbsolutePath() );
	  }
  }//GEN-LAST:event_jButton1ActionPerformed
  
  
  private File getFile() {
	  File result = null;
	  int returnVal = _chooser.showOpenDialog( this );
	  if(returnVal == JFileChooser.APPROVE_OPTION) {
		  result = _chooser.getSelectedFile();
	  }
	  return result;
  }
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JScrollPane jScrollPane1;
  private javax.swing.JList jList1;
  private javax.swing.JPanel jPanel1;
  private javax.swing.JButton jButton1;
  private javax.swing.JButton jButton2;
  private javax.swing.JLabel jLabel1;
  // End of variables declaration//GEN-END:variables
  
}
