/*
 * IControlTreeModel.java
 *
 * Created on 16. mars 2001, 00:34
 */

package no.twofingers.iControl.swing;

import javax.swing.tree.*;
import javax.swing.event.*;
import java.util.*;
import no.twofingers.iControl.*;

/**
 *
 * @author  <a href="mailto:aslak.hellesoy@bekk.no">Aslak Hellesy</a>
 */
public class IControlTreeModel extends DefaultTreeModel {
	
	/**
	 * Creates a new IControlTreeModel
	 */
	public IControlTreeModel( IControl iControl ) {
		super( new SettingTreeNode( iControl.getProject() ) );
		DBCProject project = iControl.getProject();
		SettingTreeNode projectNode = (SettingTreeNode) getRoot();
		Collection packages = project.getChildren();
		Iterator packageIterator = packages.iterator();
		while( packageIterator.hasNext() ) {
			DBCPackage pakkage = (DBCPackage) packageIterator.next();
			SettingTreeNode packageNode = new SettingTreeNode( pakkage );
			projectNode.add( packageNode );
			Collection classes = pakkage.getChildren();
			Iterator classIterator = classes.iterator();
			while( classIterator.hasNext() ) {
				DBCClass clazz = (DBCClass) classIterator.next();
				SettingTreeNode classNode = new SettingTreeNode( clazz );
				packageNode.add( classNode );
				Collection methods = clazz.getChildren();
				Iterator methodIterator = methods.iterator();
				while( methodIterator.hasNext() ) {
					DBCMethod method = (DBCMethod) methodIterator.next();
					SettingTreeNode methodNode = new SettingTreeNode( method );
					classNode.add( methodNode );
				}
			}
		}
	}
	
	public void fireChanged( SettingTreeNode settingTreeNode ) {
		TreeNode[] path = getPathToRoot( settingTreeNode );
		fireTreeStructureChanged( this, path, null, null );
	}
}
