/*
 * IControlTreeTableModel.java
 *
 * Created on 19. mars 2001, 22:37
 */

package no.twofingers.iControl.swing;

import com.sun.swing.treetable.*;
import no.twofingers.iControl.*;

/**
 *
 * @author  <a href="mailto:aslak.hellesoy@bekk.no">Aslak Hellesy</a>
 */
public class IControlTreeTableModel extends AbstractTreeTableModel {
	// Names of the columns.
	static protected String[]  cNames = { "Name", "@pre", "@post", "@invariant"};

	// Types of the columns.
	static protected Class[]  cTypes = { TreeTableModel.class, Setting.class, Setting.class, Setting.class};

	 /** Node currently being reloaded, this becomes somewhat muddy if
	  * reloading is happening in multiple threads. */
	//    protected FileNode               reloadNode;

	 /**
	  * Creates a FileSystemModel2 with the root being <code>rootPath</code>.
	  * This does not load it, you should invoke
	  * <code>reloadChildren</code> with the root to start loading.
	  */
	public IControlTreeTableModel( IControl iControl ) {
		super(null);
		root = iControl.getProject();
	}

	//
	// The TreeModel interface
	//

	public boolean isCellEditable(Object node, int column) {
		// editable unless it's a method and colums is 3 (invariant)
		return !( node instanceof DBCMethod && column == 3 );
	}

	 /**
	  * Returns the number of children of <code>node</code>.
	  */
	public int getChildCount(Object node) {
		return ((Setting) node).getChildren().size();
	}

	 /**
	  * Returns the child of <code>node</code> at index <code>i</code>.
	  */
	public Object getChild(Object node, int i) {
		return ((Setting) node).getChildren().get( i );
	}

	//
	//  The TreeTableNode interface.
	//

	 /**
	  * Returns the number of columns.
	  */
	public int getColumnCount() {
		return cNames.length;
	}

	 /**
	  * Returns the name for a particular column.
	  */
	public String getColumnName(int column) {
		return cNames[column];
	}

	 /**
	  * Returns the class for the particular column.
	  */
	public Class getColumnClass(int column) {
		return cTypes[column];
	}

	 /**
	  * Returns the value of the particular column.
	  */
	public Object getValueAt(Object node, int column) {
		Object result = null;

		Setting setting = (Setting) node;
/*
		switch(column) {
			case 0:
				result = setting;
			case 1:
			case 2:
			case 3:
				result =  setting.getSetting( Setting.INVARIANT ).equals( Setting.ON ) ? Boolean.TRUE : Boolean.FALSE;
		}
 */
		result = setting;
		return result;
	}
}
