/*
 * MainPanel.java
 *
 * Created on 26. mars 2001, 22:40
 */

package no.twofingers.iControl.swing;

import javax.swing.SwingUtilities;
import javax.swing.JLabel;
import javax.swing.JWindow;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileFilter;
import java.util.List;
import java.io.File;
import java.io.IOException;
import no.twofingers.iControl.*;

/**
 *
 * @author  Aslak Hellesy
 * @version
 */
public class MainPanel extends javax.swing.JPanel {

	private JFileChooser _chooser = new JFileChooser();
	private ConfigPanel _configPanel = new ConfigPanel();
	private AssertionPanel _assertionPanel = new AssertionPanel();
	private IControl _iControl = new IControl();

	private FileFilter _propsFilter = new FileFilter() {
		public boolean accept( File file ) {
			return file.getName().toLowerCase().endsWith( ".properties" ) || file.isDirectory();
		}

		public String getDescription() {
			return "Jar files";
		}
	};

	 /** Creates new form MainPanel */
	public MainPanel() {
		initComponents ();
		jButton1.setEnabled( false );
		_chooser.setSelectedFile( new File( System.getProperty( "user.dir" ) ) );
		_chooser.setFileFilter( _propsFilter );
		tabbedPane.addTab( "Assertions", _assertionPanel );
		tabbedPane.addTab( "Settings", _configPanel );
		//cp.setClasspath( "F:\\xml-cocoon\\xml-cocoon\\lib\\ant_1_2.jar;F:\\xml-cocoon\\xml-cocoon\\lib\\avalonapi.jar;F:\\xml-cocoon\\xml-cocoon\\lib\\batik-all.jar;F:\\xml-cocoon\\xml-cocoon\\lib\\bsf.jar;F:\\xml-cocoon\\xml-cocoon\\lib\\fop-0_16_0.jar;F:\\xml-cocoon\\xml-cocoon\\lib\\iContract-jdk1_2.jar;F:\\xml-cocoon\\xml-cocoon\\lib\\iControl.jar;F:\\xml-cocoon\\xml-cocoon\\lib\\jakarta-regexp-1.2.jar;F:\\xml-cocoon\\xml-cocoon\\lib\\jstyle.jar;F:\\xml-cocoon\\xml-cocoon\\lib\\junit.jar;F:\\xml-cocoon\\xml-cocoon\\lib\\maybeupload.jar;F:\\xml-cocoon\\xml-cocoon\\lib\\rhino.jar;F:\\xml-cocoon\\xml-cocoon\\lib\\servlet_2_2.jar;F:\\xml-cocoon\\xml-cocoon\\lib\\stylebook-1.0-b3_xalan-2.jar;F:\\xml-cocoon\\xml-cocoon\\lib\\xalan-2.0.0.jar;F:\\xml-cocoon\\xml-cocoon\\lib\\xerces_1_2_3.jar;F:\\xml-cocoon\\xml-cocoon\\lib\\xt.jar;F:\\xml-cocoon\\xml-cocoon\\build\\cocoon\\classes;F:\\xml-cocoon\\xml-cocoon\\build\\cocoon\\instrument;F:\\xml-cocoon\\xml-cocoon\\build\\cocoon\\repository;F:\\xml-cocoon\\xml-cocoon\\src;F:\\xml-cocoon\\xml-cocoon\\build\\cocoon\\instrclasses" );
	}

	 /** This method is called from within the constructor to
	  * initialize the form.
	  * WARNING: Do NOT modify this code. The content of this method is
	  * always regenerated by the FormEditor.
	  */
	private void initComponents() {//GEN-BEGIN:initComponents
		//
		tabbedPane = new javax.swing.JTabbedPane();
		jPanel1 = new javax.swing.JPanel();
		progress = new javax.swing.JLabel();
		iControlButton = new javax.swing.JButton();
		jButton1 = new javax.swing.JButton();
		setLayout(new java.awt.BorderLayout());

		//////////////
		////

		add(tabbedPane, java.awt.BorderLayout.CENTER);


		jPanel1.setLayout(new java.awt.FlowLayout(2, 5, 5));

		jPanel1.add(progress);


		iControlButton.setText("Pick properties");
  		iControlButton.addActionListener(new java.awt.event.ActionListener() {
  			public void actionPerformed(java.awt.event.ActionEvent evt) {
  				iControlButtonActionPerformed(evt);
  			}
  		}
  		);
  		jPanel1.add(iControlButton);


		jButton1.setText("Save");
  		jButton1.addActionListener(new java.awt.event.ActionListener() {
  			public void actionPerformed(java.awt.event.ActionEvent evt) {
  				jButton1ActionPerformed(evt);
  			}
  		}
  		);
  		jPanel1.add(jButton1);


		add(jPanel1, java.awt.BorderLayout.NORTH);

	}//GEN-END:initComponents

  private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
	  // Add your handling code here:
	  save();
  }//GEN-LAST:event_jButton1ActionPerformed

  private void iControlButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_iControlButtonActionPerformed
	  // Add your handling code here:
	  File propsFile = getFile();
	  if( propsFile != null ) {
		  iControlButton.setEnabled( false );
		  Setting.setIControlListener( new IControlListener() {
			  private int n = 0;
			  public void analyzingSetting( final IControlEvent e ) {
				  SwingUtilities.invokeLater( new Runnable() {
					  public void run() {
						  switch( n % 10 ) {
							  case  0: progress.setText( "|     " ); break;
							  case  1: progress.setText( " |    " ); break;
							  case  2: progress.setText( "  |   " ); break;
							  case  3: progress.setText( "   |  " ); break;
							  case  4: progress.setText( "    | " ); break;
							  case  5: progress.setText( "     |" ); break;
							  case  6: progress.setText( "    | " ); break;
							  case  7: progress.setText( "   |  " ); break;
							  case  8: progress.setText( "  |   " ); break;
							  case  9: progress.setText( " |    " ); break;
						  }
						  n++;
					  }
				  });
			  }
		  });

		  analyze( propsFile );
	  }
  }//GEN-LAST:event_iControlButtonActionPerformed

  private void analyze( final File propsFile ) {
	  Runnable analyzer = new Runnable() {
		  public void run() {
			  try {
				  _iControl.analyze( propsFile );
				  List errorClasses = _iControl.getErrorClasses();
				  if( errorClasses.size() > 0 ) {
					  Object[] unresolvedClasses = errorClasses.toArray();
					  JOptionPane.showMessageDialog(
					  MainPanel.this,
					  new Object[]{
						  unresolvedClasses[ 0 ],
						  "couldn't be analyzed. Verify that this",
						  "class and all classes it depends on are",
						  "available from your classpath."},
						  "Problem",
						  JOptionPane.ERROR_MESSAGE
						  );
				  }
				  _assertionPanel.setIControl( _iControl );
				  _configPanel.setIControl( _iControl );
				  iControlButton.setEnabled( true );
				  progress.setText( "" );
				  jButton1.setEnabled( true );
			  } catch( Throwable t ) {
				  t.printStackTrace();
			  }
		  }
	  };
	  new Thread( analyzer ).start();
  }

  public void save() {
	  try {
		  _iControl.save();
	  } catch( IOException e ) {
		  JOptionPane.showMessageDialog( this, "Couldn't save (?!)", "", JOptionPane.ERROR_MESSAGE );
	  }
  }

  private File getFile() {
	  File result = null;
	  int returnVal = _chooser.showOpenDialog( this );
	  if(returnVal == JFileChooser.APPROVE_OPTION) {
		  result = _chooser.getSelectedFile();
	  }
	  return result;
  }

  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JTabbedPane tabbedPane;
  private javax.swing.JPanel jPanel1;
  private javax.swing.JLabel progress;
  private javax.swing.JButton iControlButton;
  private javax.swing.JButton jButton1;
  // End of variables declaration//GEN-END:variables

}
