package no.twofingers.iControl.swing;

import java.awt.Component;
import java.awt.Color;
import javax.swing.*;
import javax.swing.table.*;
import no.twofingers.iControl.Setting;

public class SettingEditor extends DefaultCellEditor {
	// One of Setting.PRE, Setting.POST or Setting.INVARIANT
	private final int[] _settingFields = {
		Setting.PRE,
		Setting.POST,
		Setting.INVARIANT
	};
	
	
	public SettingEditor() {
		super( new SettingRenderer() );
	}
	
	public Component getTableCellEditorComponent(
	JTable table,
	Object value,
	boolean isSelected,
	int row,
	int column
	) {
		// get the checkbox using superclass' get method
		SettingRenderer renderer = (SettingRenderer) getComponent();
		
		// tell it to configure itself
		Component component = renderer.getTableCellRendererComponent(
			table,
			value,
			true,
			true,
			row,
			column
		);
		if( component instanceof SettingRenderer ) {
			// have to re-enable the checkbox in editor mode
			((SettingRenderer) component).setEnabled( true );
		}
		Setting setting = (Setting) value;
		setting.setSetting( _settingFields[ column - 1 ], renderer.isSelected() ? Setting.OFF : Setting.ON );
		// and tell the model to fire a complete change, since editing one cell might affect the whole treetable
		((AbstractTableModel)table.getModel() ).fireTableDataChanged();
		return renderer;
	}
}
