package no.twofingers.iControl.swing;

import java.awt.Component;
import java.awt.Color;
import javax.swing.*;
import javax.swing.table.*;
import no.twofingers.iControl.*;

public class SettingRenderer extends JCheckBox implements TableCellRenderer {
	// One of Setting.PRE, Setting.POST or Setting.INVARIANT
	private final int[] _settingFields = {
		Setting.PRE,
		Setting.POST,
		Setting.INVARIANT
	};
	
	private final JLabel label = new JLabel();
	
	public SettingRenderer() {
		super();
		setHorizontalAlignment(JLabel.CENTER);
	}
	
	public Component getTableCellRendererComponent(
	JTable table,
	Object value,
	boolean isSelected,
	boolean hasFocus,
	int row,
	int column
	) {
		/*
		if (isSelected) {
			setForeground(table.getSelectionForeground());
			super.setBackground(table.getSelectionBackground());
		}
		 */
//		else {
			setForeground(table.getForeground());
			setBackground(table.getBackground());
//		}

		
		Setting setting = (Setting) value;
		String settingValue = setting.getSetting( _settingFields[ column - 1 ] );
		setSelected( !settingValue.equals( Setting.OFF ) );
		// box looks gray when mixed
		setEnabled( !settingValue.equals( Setting.MIXED ) );
		if( value instanceof DBCMethod && column == 3 ) {
			return label;
		}
		return this;
	}
}
